#pragma once

#include <Windows.h>
#include <string>

class WinFile
{
public:
	WinFile(void);
	~WinFile(void);
	WinFile( WinFile&);

	
	bool Fopen( const std::wstring& , const wchar_t *  ); //   ( w, a, r )
	void Fclose(); //   
	bool SetCursor( const LONGLONG& ,const int& ); //     (FILE_BEGIN | FILE_CURRENT | FILE_END)
	bool ClearFile( void ); //  
	std::wstring GetTextError();//    
	int GetError();//   
	ULONGLONG GetFileSize( void );//   
	bool SetEndFile(const ULONGLONG & , const int&); //   
	DWORD GetRW(void);

	static ULONGLONG GetFileSize( const std::wstring& );//   
	static bool file_exists( const std::wstring& ); //    
	static int Delete_File( const std::wstring& );
	static int Copy_File( const std::wstring& /**/, const std::wstring& /**/, int& /* */ , bool& /*(1 - , 0 -  )*/ );
	static int Copy_File( const std::wstring& /**/, const std::wstring& /**/);
	static int Rename_File(const std::wstring& /*  */, const std::wstring&  /**/ );
	static int file_get_contents(const std::wstring& /*  */, std::wstring& /* */);
	static int file_put_contents(const std::wstring& /*  */, std::wstring& /* */);
	static int file_get_contents(const std::wstring& /*  */, std::string& /* */);
	static int file_put_contents(const std::wstring& /*  */, std::string& /* */);

	bool Fread( std::string& );
	bool Fread( std::wstring& );
	bool Fread( std::string& , const DWORD& );
	bool Fread( std::wstring& ,  const DWORD& );
	bool Fread( LPVOID ,const DWORD &); 
	bool Fread( int& );
	bool Fread( bool& );
	bool Fread( float& );
	bool Fread( LONG& );
	bool Fread( LONGLONG& );
	bool Fread( ULONGLONG& );
	bool Fread( DWORD& );


	bool Fwrite( std::string& );
	bool Fwrite( std::wstring& );
	bool Fwrite( LPVOID ,const DWORD &); 
	bool Fwrite( int& );
	bool Fwrite( bool& );
	bool Fwrite( float& );
	bool Fwrite( LONG& );
	bool Fwrite( LONGLONG& );
	bool Fwrite( ULONGLONG& );
	bool Fwrite( DWORD& );
	bool Fwrite( int&& );
	bool Fwrite( bool&& );
	bool Fwrite( float&& );
	bool Fwrite( LONG&& );
	bool Fwrite( LONGLONG&& );
	bool Fwrite( ULONGLONG&& );
	bool Fwrite( DWORD&& );

private:

	void GetLastErrorText();

	HANDLE Hfile;
	DWORD attr,rw;
	bool isOpen;
	std::wstring error;
	int LastErrorCode;
};

